# -*- coding: utf-8 -*-
import codecs

# generated by genmapping.py
utf82latex={
34:"''", 	# character "
35:'\\#', 	# character #
36:'\\$', 	# character $
37:'\\%', 	# character %
38:'\\&', 	# character &
95:'\\_', 	# character _
123:'\\{', 	# character {
125:'\\}', 	# character }
160:'~', 	# character  
161:'\\textexclamdown', 	# character ¡
162:'\\textcent', 	# character ¢
163:'\\textsterling', 	# character £
164:'\\textcurrency', 	# character ¤
165:'\\textyen', 	# character ¥
166:'\\textbrokenbar', 	# character ¦
167:'\\textsection', 	# character §
168:'\\textasciidieresis', 	# character ¨
169:'\\textcopyright', 	# character ©
170:'\\textordfeminine', 	# character ª
171:'\\guillemotleft', 	# character «
172:'\\textlnot', 	# character ¬
174:'\\textregistered', 	# character ®
175:'\\textasciimacron', 	# character ¯
176:'\\textdegree', 	# character °
177:'\\textpm', 	# character ±
178:'\\texttwosuperior', 	# character ²
179:'\\textthreesuperior', 	# character ³
180:'\\textasciiacute', 	# character ´
181:'\\textmu', 	# character µ
182:'\\textparagraph', 	# character ¶
183:'\\textperiodcentered', 	# character ·
185:'\\textonesuperior', 	# character ¹
186:'\\textordmasculine', 	# character º
187:'\\guillemotright', 	# character »
188:'\\textonequarter', 	# character ¼
189:'\\textonehalf', 	# character ½
190:'\\textthreequarters', 	# character ¾
191:'\\textquestiondown', 	# character ¿
192:'\\`A', 	# character À
193:"\\'A", 	# character Á
194:'\\^A', 	# character Â
195:'\\~A', 	# character Ã
196:'\\"A', 	# character Ä
197:'\\r{A}', 	# character Å
198:'\\AE', 	# character Æ
199:'\\c{C}', 	# character Ç
200:'\\`E', 	# character È
201:"\\'E", 	# character É
202:'\\^E', 	# character Ê
203:'\\"E', 	# character Ë
204:'\\`I', 	# character Ì
205:"\\'I", 	# character Í
206:'\\^I', 	# character Î
207:'\\"I', 	# character Ï
208:'\\DH', 	# character Ð
209:'\\~N', 	# character Ñ
210:'\\`O', 	# character Ò
211:"\\'O", 	# character Ó
212:'\\^O', 	# character Ô
213:'\\~O', 	# character Õ
214:'\\"O', 	# character Ö
215:'\\texttimes', 	# character ×
216:'\\O', 	# character Ø
217:'\\`U', 	# character Ù
218:"\\'U", 	# character Ú
219:'\\^U', 	# character Û
220:'\\"U', 	# character Ü
221:"\\'Y", 	# character Ý
222:'\\TH', 	# character Þ
223:'\\ss', 	# character ß
224:'\\`a', 	# character à
225:"\\'a", 	# character á
226:'\\^a', 	# character â
227:'\\~a', 	# character ã
228:'\\"a', 	# character ä
229:'\\r{a}', 	# character å
230:'\\ae', 	# character æ
231:'\\c{c}', 	# character ç
232:'\\`e', 	# character è
233:"\\'e", 	# character é
234:'\\^e', 	# character ê
235:'\\"e', 	# character ë
236:'\\`\\i', 	# character ì
237:"\\'\\i", 	# character í
238:'\\^\\i', 	# character î
239:'\\"\\i', 	# character ï
240:'\\dh', 	# character ð
241:'\\~n', 	# character ñ
242:'\\`o', 	# character ò
243:"\\'o", 	# character ó
244:'\\^o', 	# character ô
245:'\\~o', 	# character õ
246:'\\"o', 	# character ö
247:'\\textdiv', 	# character ÷
248:'\\o', 	# character ø
249:'\\`u', 	# character ù
250:"\\'u", 	# character ú
251:'\\^u', 	# character û
252:'\\"u', 	# character ü
253:"\\'y", 	# character ý
254:'\\th', 	# character þ
255:'\\"y', 	# character ÿ
256:'\\={A}', 	# character Ā
257:'\\={a}', 	# character ā
258:'\\u{A}', 	# character Ă
259:'\\u{a}', 	# character ă
260:'\\k{A}', 	# character Ą
261:'\\k{a}', 	# character ą
262:"\\'C", 	# character Ć
263:"\\'c", 	# character ć
264:'\\^{C}', 	# character Ĉ
265:'\\^{c}', 	# character ĉ
266:'\\.{C}', 	# character Ċ
267:'\\.{c}', 	# character ċ
268:'\\v{C}', 	# character Č
269:'\\v{c}', 	# character č
270:'\\v{D}', 	# character Ď
271:'\\v{d}', 	# character ď
272:'\\DJ', 	# character Đ
273:'\\dj', 	# character đ
274:'\\={E}', 	# character Ē
275:'\\={e}', 	# character ē
276:'\\u{E}', 	# character Ĕ
277:'\\u{e}', 	# character ĕ
278:'\\.{E}', 	# character Ė
279:'\\.{e}', 	# character ė
280:'\\k{E}', 	# character Ę
281:'\\k{e}', 	# character ę
282:'\\v{E}', 	# character Ě
283:'\\v{e}', 	# character ě
284:'\\^{G}', 	# character Ĝ
285:'\\^{g}', 	# character ĝ
286:'\\u{G}', 	# character Ğ
287:'\\u{g}', 	# character ğ
288:'\\.{G}', 	# character Ġ
289:'\\.{g}', 	# character ġ
290:'\\c{G}', 	# character Ģ
291:'\\c{g}', 	# character ģ
292:'\\^{H}', 	# character Ĥ
293:'\\^{h}', 	# character ĥ
294:'\\={H}', 	# character Ħ
295:'\\={h}', 	# character ħ
296:'\\~{I}', 	# character Ĩ
297:'\\~{i}', 	# character ĩ
298:'\\={I}', 	# character Ī
299:'\\={i}', 	# character ī
300:'\\u{I}', 	# character Ĭ
301:'\\u{i}', 	# character ĭ
302:'\\k{I}', 	# character Į
303:'\\k{i}', 	# character į
304:'\\.I', 	# character İ
305:'\\i', 	# character ı
306:'\\IJ', 	# character Ĳ
307:'\\ij', 	# character ĳ
308:'\\^{J}', 	# character Ĵ
309:'\\^{j}', 	# character ĵ
310:'\\c{K}', 	# character Ķ
311:'\\c{k}', 	# character ķ
312:'ĸ', 	# character ĸ
313:"\\'L", 	# character Ĺ
314:"\\'l", 	# character ĺ
315:'\\c{L}', 	# character Ļ
316:'\\c{l}', 	# character ļ
317:'\\v{L}', 	# character Ľ
318:'\\v{l}', 	# character ľ
319:'\\.{L}', 	# character Ŀ
320:'\\.{l}', 	# character ŀ
321:'\\L', 	# character Ł
322:'\\l', 	# character ł
323:"\\'N", 	# character Ń
324:"\\'n", 	# character ń
325:'\\c{N}', 	# character Ņ
326:'\\c{n}', 	# character ņ
327:'\\v{N}', 	# character Ň
328:'\\v{n}', 	# character ň
329:'\\nument{149}', 	# character ŉ
330:'\\NG', 	# character Ŋ
331:'\\ng', 	# character ŋ
332:'\\={O}', 	# character Ō
333:'\\={o}', 	# character ō
334:'\\u{O}', 	# character Ŏ
335:'\\u{o}', 	# character ŏ
336:"\\'{O}", 	# character Ő
337:"\\'{o}", 	# character ő
338:'\\OE', 	# character Œ
339:'\\oe', 	# character œ
340:"\\'R", 	# character Ŕ
341:"\\'r", 	# character ŕ
342:'\\c{R}', 	# character Ŗ
343:'\\c{r}', 	# character ŗ
344:'\\v{R}', 	# character Ř
345:'\\v{r}', 	# character ř
346:"\\'S", 	# character Ś
347:"\\'s", 	# character ś
348:'\\^{S}', 	# character Ŝ
349:'\\^{s}', 	# character ŝ
350:'\\c{S}', 	# character Ş
351:'\\c{s}', 	# character ş
352:'\\v{S}', 	# character Š
353:'\\v{s}', 	# character š
354:'\\c{T}', 	# character Ţ
355:'\\c{t}', 	# character ţ
356:'\\v{T}', 	# character Ť
357:'\\v{t}', 	# character ť
358:'\\={T}', 	# character Ŧ
359:'\\={t}', 	# character ŧ
360:'\\~{U}', 	# character Ũ
361:'\\~{u}', 	# character ũ
362:'\\={U}', 	# character Ū
363:'\\={u}', 	# character ū
364:'\\u{U}', 	# character Ŭ
365:'\\u{u}', 	# character ŭ
366:'\\r{U}', 	# character Ů
367:'\\r{u}', 	# character ů
368:"\\'{U}", 	# character Ű
369:"\\'{u}", 	# character ű
370:'\\k{U}', 	# character Ų
371:'\\k{u}', 	# character ų
372:'\\^{W}', 	# character Ŵ
373:'\\^{w}', 	# character ŵ
374:'\\^{Y}', 	# character Ŷ
375:'\\^{y}', 	# character ŷ
376:'\\"Y', 	# character Ÿ
377:"\\'Z", 	# character Ź
378:"\\'z", 	# character ź
379:'\\.Z', 	# character Ż
380:'\\.z', 	# character ż
381:'\\v{Z}', 	# character Ž
382:'\\v{z}', 	# character ž
402:'\\textflorin', 	# character ƒ
710:'\\textasciicircum', 	# character ˆ
711:'\\textasciicaron', 	# character ˇ
728:'\\textasciibreve', 	# character ˘
732:'\\textasciitilde', 	# character ˜
733:'\\textacutedbl', 	# character ˝
1024:'\\`\\CYRE', 	# character Ѐ
1025:'\\CYRYO', 	# character Ё
1026:'\\CYRDJE', 	# character Ђ
1027:'\\`\\CYRG', 	# character Ѓ
1028:'\\CYRIE', 	# character Є
1029:'\\CYRDZE', 	# character Ѕ
1030:'\\CYRII', 	# character І
1031:'\\CYRYI', 	# character Ї
1032:'\\CYRJE', 	# character Ј
1033:'\\CYRLJE', 	# character Љ
1034:'\\CYRNJE', 	# character Њ
1035:'\\CYRTSHE', 	# character Ћ
1036:'\\`\\CYRK', 	# character Ќ
1037:'\\`\\CYRI', 	# character Ѝ
1038:'\\CYRUSHRT', 	# character Ў
1039:'\\CYRDZHE', 	# character Џ
1040:'\\CYRA', 	# character А
1041:'\\CYRB', 	# character Б
1042:'\\CYRV', 	# character В
1043:'\\CYRG', 	# character Г
1044:'\\CYRD', 	# character Д
1045:'\\CYRE', 	# character Е
1046:'\\CYRZH', 	# character Ж
1047:'\\CYRZ', 	# character З
1048:'\\CYRI', 	# character И
1049:'\\CYRISHRT', 	# character Й
1050:'\\CYRK', 	# character К
1051:'\\CYRL', 	# character Л
1052:'\\CYRM', 	# character М
1053:'\\CYRN', 	# character Н
1054:'\\CYRO', 	# character О
1055:'\\CYRP', 	# character П
1056:'\\CYRR', 	# character Р
1057:'\\CYRS', 	# character С
1058:'\\CYRT', 	# character Т
1059:'\\CYRU', 	# character У
1060:'\\CYRF', 	# character Ф
1061:'\\CYRH', 	# character Х
1062:'\\CYRC', 	# character Ц
1063:'\\CYRCH', 	# character Ч
1064:'\\CYRSH', 	# character Ш
1065:'\\CYRSHCH', 	# character Щ
1066:'\\CYRHRDSN', 	# character Ъ
1067:'\\CYRERY', 	# character Ы
1068:'\\CYRSFTSN', 	# character Ь
1069:'\\CYREREV', 	# character Э
1070:'\\CYRYU', 	# character Ю
1071:'\\CYRYA', 	# character Я
1072:'\\cyra', 	# character а
1073:'\\cyrb', 	# character б
1074:'\\cyrv', 	# character в
1075:'\\cyrg', 	# character г
1076:'\\cyrd', 	# character д
1077:'\\cyre', 	# character е
1078:'\\cyrzh', 	# character ж
1079:'\\cyrz', 	# character з
1080:'\\cyri', 	# character и
1081:'\\cyrishrt', 	# character й
1082:'\\cyrk', 	# character к
1083:'\\cyrl', 	# character л
1084:'\\cyrm', 	# character м
1085:'\\cyrn', 	# character н
1086:'\\cyro', 	# character о
1087:'\\cyrp', 	# character п
1088:'\\cyrr', 	# character р
1089:'\\cyrs', 	# character с
1090:'\\cyrt', 	# character т
1091:'\\cyru', 	# character у
1092:'\\cyrf', 	# character ф
1093:'\\cyrh', 	# character х
1094:'\\cyrc', 	# character ц
1095:'\\cyrch', 	# character ч
1096:'\\cyrsh', 	# character ш
1097:'\\cyrshch', 	# character щ
1098:'\\cyrhrdsn', 	# character ъ
1099:'\\cyrery', 	# character ы
1100:'\\cyrsftsn', 	# character ь
1101:'\\cyrerev', 	# character э
1102:'\\cyryu', 	# character ю
1103:'\\cyrya', 	# character я
1104:'\\`\\cyre', 	# character ѐ
1105:'\\cyryo', 	# character ё
1106:'\\cyrdje', 	# character ђ
1107:'\\`\\cyrg', 	# character ѓ
1108:'\\cyrie', 	# character є
1109:'\\cyrdze', 	# character ѕ
1110:'\\cyrii', 	# character і
1111:'\\cyryi', 	# character ї
1112:'\\cyrje', 	# character ј
1113:'\\cyrlje', 	# character љ
1114:'\\cyrnje', 	# character њ
1115:'\\cyrtshe', 	# character ћ
1116:'\\`\\cyrk', 	# character ќ
1117:'\\`\\cyri', 	# character ѝ
1118:'\\cyrushrt', 	# character ў
1119:'\\cyrdzhe', 	# character џ
1122:'\\CYRYAT', 	# character Ѣ
1123:'\\cyryat', 	# character ѣ
1130:'\\CYRBYUS', 	# character Ѫ
1131:'\\cyrbyus', 	# character ѫ
1138:'\\CYRFITA', 	# character Ѳ
1139:'\\cyrfita', 	# character ѳ
1140:'\\CYRIZH', 	# character Ѵ
1141:'\\cyrizh', 	# character ѵ
1142:'\\C\\CYRIZH', 	# character Ѷ
1143:'\\C\\cyrizh', 	# character ѷ
1164:'\\CYRSEMISFTSN', 	# character Ҍ
1165:'\\cyrsemisftsn', 	# character ҍ
1166:'\\CYRRTICK', 	# character Ҏ
1167:'\\cyrrtick', 	# character ҏ
1168:'\\CYRGUP', 	# character Ґ
1169:'\\cyrgup', 	# character ґ
1170:'\\CYRGHCRS', 	# character Ғ
1171:'\\cyrghcrs', 	# character ғ
1172:'\\CYRGHK', 	# character Ҕ
1173:'\\cyrghk', 	# character ҕ
1174:'\\CYRZHDSC', 	# character Җ
1175:'\\cyrzhdsc', 	# character җ
1176:'\\CYRZDSC', 	# character Ҙ
1177:'\\cyrzdsc', 	# character ҙ
1178:'\\CYRKDSC', 	# character Қ
1179:'\\cyrkdsc', 	# character қ
1180:'\\CYRKVCRS', 	# character Ҝ
1181:'\\cyrkvcrs', 	# character ҝ
1182:'\\CYRKHCRS', 	# character Ҟ
1183:'\\cyrkhcrs', 	# character ҟ
1184:'\\CYRKBEAK', 	# character Ҡ
1185:'\\cyrkbeak', 	# character ҡ
1186:'\\CYRNDSC', 	# character Ң
1187:'\\cyrndsc', 	# character ң
1188:'\\CYRNG', 	# character Ҥ
1189:'\\cyrng', 	# character ҥ
1190:'\\CYRPHK', 	# character Ҧ
1191:'\\cyrphk', 	# character ҧ
1192:'\\CYRABHHA', 	# character Ҩ
1193:'\\cyrabhha', 	# character ҩ
1194:'\\CYRSDSC', 	# character Ҫ
1195:'\\cyrsdsc', 	# character ҫ
1196:'\\CYRTDSC', 	# character Ҭ
1197:'\\cyrtdsc', 	# character ҭ
1198:'\\CYRY', 	# character Ү
1199:'\\cyry', 	# character ү
1200:'\\CYRYHCRS', 	# character Ұ
1201:'\\cyryhcrs', 	# character ұ
1202:'\\CYRHDSC', 	# character Ҳ
1203:'\\cyrhdsc', 	# character ҳ
1204:'\\CYRTETSE', 	# character Ҵ
1205:'\\cyrtetse', 	# character ҵ
1206:'\\CYRCHRDSC', 	# character Ҷ
1207:'\\cyrchrdsc', 	# character ҷ
1208:'\\CYRCHVCRS', 	# character Ҹ
1209:'\\cyrchvcrs', 	# character ҹ
1210:'\\CYRSHHA', 	# character Һ
1211:'\\cyrshha', 	# character һ
1212:'\\CYRABHCH', 	# character Ҽ
1213:'\\cyrabhch', 	# character ҽ
1214:'\\CYRABHCHDSC', 	# character Ҿ
1215:'\\cyrabhchdsc', 	# character ҿ
1216:'\\CYRpalochka', 	# character Ӏ
1217:'\\U\\CYRZH', 	# character Ӂ
1218:'\\U\\cyrzh', 	# character ӂ
1219:'\\CYRKHK', 	# character Ӄ
1220:'\\cyrkhk', 	# character ӄ
1221:'\\CYRLDSC', 	# character Ӆ
1222:'\\cyrldsc', 	# character ӆ
1223:'\\CYRNHK', 	# character Ӈ
1224:'\\cyrnhk', 	# character ӈ
1227:'\\CYRCHLDSC', 	# character Ӌ
1228:'\\cyrchldsc', 	# character ӌ
1229:'\\CYRMDSC', 	# character Ӎ
1230:'\\cyrmdsc', 	# character ӎ
1232:'\\U\\CYRA', 	# character Ӑ
1233:'\\U\\cyra', 	# character ӑ
1234:'\\"\\CYRA', 	# character Ӓ
1235:'\\"\\cyra', 	# character ӓ
1236:'\\CYRAE', 	# character Ӕ
1237:'\\cyrae', 	# character ӕ
1238:'\\U\\CYRE', 	# character Ӗ
1239:'\\U\\cyre', 	# character ӗ
1240:'\\CYRSCHWA', 	# character Ә
1241:'\\cyrschwa', 	# character ә
1242:'\\"\\CYRSCHWA', 	# character Ӛ
1243:'\\"\\cyrschwa', 	# character ӛ
1244:'\\"\\CYRZH', 	# character Ӝ
1245:'\\"\\cyrzh', 	# character ӝ
1246:'\\"\\CYRZ', 	# character Ӟ
1247:'\\"\\cyrz', 	# character ӟ
1248:'\\CYRABHDZE', 	# character Ӡ
1249:'\\cyrabhdze', 	# character ӡ
1250:'\\=\\CYRI', 	# character Ӣ
1251:'\\=\\cyri', 	# character ӣ
1252:'\\"\\CYRI', 	# character Ӥ
1253:'\\"\\cyri', 	# character ӥ
1254:'\\"\\CYRO', 	# character Ӧ
1255:'\\"\\cyro', 	# character ӧ
1256:'\\CYROTLD', 	# character Ө
1257:'\\cyrotld', 	# character ө
1260:'\\"\\CYREREV', 	# character Ӭ
1261:'\\"\\cyrerev', 	# character ӭ
1262:'\\=\\CYRU', 	# character Ӯ
1263:'\\=\\cyru', 	# character ӯ
1264:'\\"\\CYRU', 	# character Ӱ
1265:'\\"\\cyru', 	# character ӱ
1266:'\\H\\CYRU', 	# character Ӳ
1267:'\\H\\cyru', 	# character ӳ
1268:'\\"\\CYRCH', 	# character Ӵ
1269:'\\"\\cyrch', 	# character ӵ
1270:'\\CYRGDSC', 	# character Ӷ
1271:'\\cyrgdsc', 	# character ӷ
1272:'\\"\\CYRERY', 	# character Ӹ
1273:'\\"\\cyrery', 	# character ӹ
1274:'\\CYRGDSCHCRS', 	# character Ӻ
1275:'\\cyrgdschcrs', 	# character ӻ
1276:'\\CYRHHK', 	# character Ӽ
1277:'\\cyrhhk', 	# character ӽ
1278:'\\CYRHHCRS', 	# character Ӿ
1279:'\\cyrhhcrs', 	# character ӿ
3647:'\\textbaht', 	# character ฿
8204:'\\textcompwordmark', 	# character ‌
8211:'\\textendash', 	# character –
8212:'\\textemdash', 	# character —
8214:'\\textbardbl', 	# character ‖
8216:'\\textquoteleft', 	# character ‘
8217:'\\textquoteright', 	# character ’
8218:'\\quotesinglbase', 	# character ‚
8220:'\\textquotedblleft', 	# character “
8221:'\\textquotedblright', 	# character ”
8222:'\\quotedblbase', 	# character „
8224:'\\textdagger', 	# character †
8225:'\\textdaggerdbl', 	# character ‡
8226:'\\textbullet', 	# character •
8230:'\\textellipsis', 	# character …
8240:'\\textperthousand', 	# character ‰
8241:'\\textpertenthousand', 	# character ‱
8249:'\\guilsinglleft', 	# character ‹
8250:'\\guilsinglright', 	# character ›
8251:'\\textreferencemark', 	# character ※
8253:'\\textinterrobang', 	# character ‽
8260:'\\textfractionsolidus', 	# character ⁄
8270:'\\textasteriskcentered', 	# character ⁎
8274:'\\textdiscount', 	# character ⁒
8353:'\\textcolonmonetary', 	# character ₡
8356:'\\textlira', 	# character ₤
8358:'\\textnaira', 	# character ₦
8361:'\\textwon', 	# character ₩
8363:'\\textdong', 	# character ₫
8364:'\\texteuro', 	# character €
8369:'\\textpeso', 	# character ₱
8451:'\\textcelsius', 	# character ℃
8470:'\\textnumero', 	# character №
8471:'\\textcircledP', 	# character ℗
8478:'\\textrecipe', 	# character ℞
8480:'\\textservicemark', 	# character ℠
8482:'\\texttrademark', 	# character ™
8486:'\\textohm', 	# character Ω
8487:'\\textmho', 	# character ℧
8494:'\\textestimated', 	# character ℮
8592:'\\textleftarrow', 	# character ←
8593:'\\textuparrow', 	# character ↑
8594:'\\textrightarrow', 	# character →
8595:'\\textdownarrow', 	# character ↓
9001:'\\textlangle', 	# character 〈
9002:'\\textrangle', 	# character 〉
9250:'\\textblank', 	# character ␢
9251:'\\textvisiblespace', 	# character ␣
9702:'\\textopenbullet', 	# character ◦
9711:'\\textbigcircle', 	# character ◯
9834:'\\textmusicalnote'	# character ♪

}

latex2utf8=dict((v,k) for k, v in utf82latex.iteritems())

class LatexCodec(codecs.Codec):
	def __init__(self, brackets):
		self.brackets = brackets
	def encode(self,input):
		if not input:
			return "", 0
		result=""
		for ch in input:
			#print ord(ch)
			#print unichr(ord(ch))
			if ord(ch) in utf82latex:
				trans=utf82latex[ord(ch)]
				if '\\' in trans and self.brackets:
					result+="{"+trans+"}"
				else:
					result+=trans
			else:
				result+=ch
		return result, len(input)				

	def decode(self,input):
	
		return input, len(input)

def getregentry(encname):
	if encname=='latex':
		return codecs.CodecInfo(
			name='latex',
			encode=LatexCodec(False).encode,
			decode=None,
			incrementalencoder=None,
			incrementaldecoder=None,
			streamwriter=None,
			streamreader=None)
	elif encname=='latex_bracket':
		return codecs.CodecInfo(
			name='latex_bracket',
			encode=LatexCodec(True).encode,
			decode=None,
			incrementalencoder=None,
			incrementaldecoder=None,
			streamwriter=None,
			streamreader=None)
	else:
		return None

codecs.register(getregentry)
#printMappingTable()
